Imports System.Data.OleDb

Public Class DataGridForm
    Inherits System.Web.UI.Page

    Protected WithEvents dgrTitles As System.Web.UI.WebControls.DataGrid

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub
    Protected WithEvents btnUpdate As System.Web.UI.WebControls.Button
    Protected WithEvents lblTotal As System.Web.UI.WebControls.Label
    Protected WithEvents btnEval As System.Web.UI.WebControls.Button

#End Region

    ' The DataSet that contains the data.
    Dim ds As New DataSet()

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not Me.IsPostBack Then
            ' If this is the first time the form is displayed, read the DataSet
            ' and store it in a Session variable.
            FillDataSet()
            Session("DataSet") = ds
            ' Bind the DataGrid control.
            BindDataGrid()
        Else
            ' If this is a postback, just retrieve the DataSet from the Session variable.
            ds = DirectCast(Session("DataSet"), DataSet)
        End If
    End Sub

    ' Fill the DataSet from the Pubs database.
    Sub FillDataSet()
        Dim cn As New OleDbConnection(OledbPubsConnString)
        cn.Open()
        ' Fill the Titles DataTable.
        Dim daTitles As New OleDbDataAdapter("SELECT * FROM Titles", cn)
        daTitles.Fill(ds, "Titles")

        ' Fill the Publishers DataTable.
        Dim daPubs As New OleDbDataAdapter("SELECT pub_id,pub_name FROM Publishers", cn)
        daPubs.Fill(ds, "Publishers")
        ' Close the connection
        cn.Close()
        ' Create the relation between the two tables.
        ds.Relations.Add("PubsTitles", ds.Tables("Publishers").Columns("pub_id"), ds.Tables("Titles").Columns("pub_id"))
    End Sub

    ' Bind the DataGrid control.
    Sub BindDataGrid()
        ' Bind the data source to the DataGrid.
        dgrTitles.DataSource = ds.Tables("Titles")
        dgrTitles.DataKeyField = "title_id"

        ' Retrieve the SortExpression. This value is stored into the 
        ' SortExpr attribute, so that its initial value can be edited
        ' directly in the HTML view 
        Dim sortExpr As String = dgrTitles.Attributes("SortExpr")

        ' if the grid must be sorted, then we need to bind to a DataView
        ' instead of directly to the DataGrid

        If Not (sortExpr Is Nothing) AndAlso sortExpr.ToString.Length > 0 Then
            ' We must bind to a sorted DataView object instead.
            Dim dv As DataView = ds.Tables("Titles").DefaultView
            dv.Sort = sortExpr.ToString
            dgrTitles.DataSource = dv
        End If

        ' Do the binding.
        dgrTitles.DataBind()

        ' If we are in edit mode, also bind the ddlPublishers control.
        If dgrTitles.EditItemIndex >= 0 Then
            ' Get a reference to the ddlPublishers control.
            Dim dgi As DataGridItem = dgrTitles.Items(dgrTitles.EditItemIndex)
            Dim ddlPublishers As DropDownList = DirectCast(dgi.FindControl("ddlPublishers"), DropDownList)

            ' Bind it to the Publishers DataTable.
            ddlPublishers.DataSource = ds.Tables("Publishers")
            ddlPublishers.DataTextField = "pub_name"
            ddlPublishers.DataValueField = "pub_id"
            ddlPublishers.DataBind()

            ' Highlight the publisher of the current title
            Dim dr As DataRow = GetDataRow(dgrTitles.DataKeys(dgrTitles.EditItemIndex).ToString)
            SelectItemFromValue(ddlPublishers, dr("pub_id").ToString)
        End If

    End Sub

    ' this event fires when the Edit button is clicked 

    Private Sub dgrTitles_EditCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgrTitles.EditCommand
        ' Enter the edit mode and rebind the control.
        dgrTitles.EditItemIndex = e.Item.ItemIndex
        BindDataGrid()
    End Sub

    ' this event handler fires when the Cancel button is clicked

    Private Sub dgrTitles_CancelCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgrTitles.CancelCommand
        ' Exit edit mode.
        dgrTitles.EditItemIndex = -1
        BindDataGrid()
    End Sub

    ' this event handler fires when the Delete button is clicked

    Private Sub dgrTitles_DeleteCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgrTitles.DeleteCommand
        ' Get a reference to the DataGridItem being deleted.
        Dim dgi As DataGridItem = dgrTitles.Items(e.Item.ItemIndex)
        ' Get the DataRow with the corresponding key value.
        Dim dr As DataRow = GetDataRow(dgrTitles.DataKeys(e.Item.ItemIndex).ToString)
        ' delete it and rebind the control.
        dr.Delete()
        BindDataGrid()
    End Sub

    ' this event handler fires when the Update button is clicked

    Private Sub dgrTitles_UpdateCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgrTitles.UpdateCommand
        ' Get a reference to the DataGridItem being edited.
        Dim dgi As DataGridItem = dgrTitles.Items(e.Item.ItemIndex)
        ' Get the DataRow with the corresponding key value.
        Dim dr As DataRow = GetDataRow(dgrTitles.DataKeys(e.Item.ItemIndex).ToString)

        ' Update DataRow columns. To do that, we must read data
        ' stored in the fields contained in the template

        ' The title field comes from the first (only) control in the second cell in this row.
        dr("title") = DirectCast(dgi.Cells(1).Controls(0), TextBox).Text
        ' The pub_id field comes from the current value of the ddlPublishers control.
        Dim ddlPublishers As DropDownList = DirectCast(dgi.FindControl("ddlPublishers"), DropDownList)
        dr("pub_id") = ddlPublishers.SelectedItem.Value
        ' The type field comes from the first (only) control in the fourth cell in this row.
        dr("type") = DirectCast(dgi.Cells(3).Controls(0), TextBox).Text
        ' The price field comes from the first (only) control in the fifth cell in this row.
        dr("price") = CDec(DirectCast(dgi.Cells(4).Controls(0), TextBox).Text)

        ' Exit edit mode and rebind the DataGrid.
        dgrTitles.EditItemIndex = -1
        BindDataGrid()
    End Sub

    ' This auxiliary routine returns the DataRow with a given key value.

    Function GetDataRow(ByVal id As String) As DataRow
        ' Select the DataTable rows with this key value.
        Dim drows() As DataRow = ds.Tables("Titles").Select("title_id='" & id & "'")
        ' Return the DataRow if found.
        If drows.Length > 0 Then
            Return drows(0)
        End If
    End Function

    ' this routine shows how you can work with all the "selected" rows
    ' (a selected row is a row whose first column contains a selected checkbox)

    Private Sub btnEval_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEval.Click
        ' Purchase all titles that have a selected checkbox.
        Dim totalPrice As Decimal
        Dim count As Integer
        Dim dgi As DataGridItem

        For Each dgi In dgrTitles.Items
            ' Get a reference to the CheckBox control in this item.
            Dim cb As CheckBox = DirectCast(dgi.FindControl("chkSelect"), CheckBox)
            ' If checked, delete this element.
            If cb.Checked Then
                ' Get the title_id key value for this row.
                Dim id As String = dgrTitles.DataKeys(dgi.ItemIndex).ToString
                ' Select the DataTable row with this key value.
                Dim dr As DataRow = GetDataRow(id)
                If Not dr.IsNull("price") Then
                    ' Add the price to the running total.
                    totalPrice += CDec(dr("price"))
                    count += 1
                End If
            End If
        Next

        ' Display the total
        lblTotal.Text = String.Format("Total price for {0} selected book(s) is ${1}", count, totalPrice)
    End Sub

    ' this event handler fires when the Update button is clicked

    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        ' Update the Pubs database.
        ' (this demo doesn't do anything)
    End Sub

    ' this event handler fires when a hyperlink in a column header is clicked

    Private Sub dgrTitles_SortCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridSortCommandEventArgs) Handles dgrTitles.SortCommand
        ' Extract current sort column and order.
        Dim currSortExpr As String = dgrTitles.Attributes("SortExpr")
        Dim newSortExpr As String = e.SortExpression

        ' If the sort expression is the same as the current one, just reverse the direction.
        If Not (currSortExpr Is Nothing) AndAlso currSortExpr.ToString = e.SortExpression Then
            newSortExpr &= " DESC"
        End If

        ' Remember the new sort expression and rebind.
        dgrTitles.Attributes("SortExpr") = newSortExpr
        BindDataGrid()
    End Sub

End Class
