Imports System.Data.OleDb

Public Class DynamicTemplateForm
    Inherits System.Web.UI.Page
    Protected WithEvents ddlItemTemplate As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddlAlternateTemplate As System.Web.UI.WebControls.DropDownList
    Protected WithEvents btnCustom As System.Web.UI.WebControls.Button
    Protected WithEvents DataList1 As System.Web.UI.WebControls.DataList

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Load template names in the two DropDownList controls
        If Not Me.IsPostBack Then
            ' Load template names in a hashtable.
            Dim ht As New Hashtable(4)
            ht.Add("Black on yellow", "Black_on_yellow.ascx")
            ht.Add("Blue on orange", "Blue_on_orange.ascx")
            ht.Add("Blue on white", "Blue_on_white.ascx")
            ht.Add("White on blue", "White_on_blue.ascx")

            ' Load these values into the two DropDownList controls
            ddlItemTemplate.DataSource = ht
            ddlItemTemplate.DataTextField = "Key"
            ddlItemTemplate.DataValueField = "Value"
            ddlItemTemplate.DataBind()

            ddlAlternateTemplate.DataSource = ht
            ddlAlternateTemplate.DataTextField = "Key"
            ddlAlternateTemplate.DataValueField = "Value"
            ddlAlternateTemplate.DataBind()

            ' ensure no item is selected
            ddlItemTemplate.SelectedIndex = -1
            ddlAlternateTemplate.SelectedIndex = -1

            BindDataList()
        End If
    End Sub

    ' Display some titles from the Pubs database

    Sub BindDataList()
        Dim cn As New OleDbConnection(OledbPubsConnString)
        cn.Open()
        Dim cmd As New OleDbCommand("SELECT * FROM Titles", cn)
        Dim dr As OleDbDataReader = cmd.ExecuteReader
        DataList1.DataSource = dr
        DataList1.DataBind()
        dr.Close()
        cn.Close()
    End Sub

    ' Load a new .ascx from file

    Private Sub ddlItemTemplate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlItemTemplate.SelectedIndexChanged, ddlAlternateTemplate.SelectedIndexChanged
        ' Get the name of the template file.
        Dim file As String = ddlItemTemplate.SelectedItem.Value
        ' Load the template and rebind the DataList control.
        DataList1.ItemTemplate = Me.LoadTemplate(file)

        ' Get the name of the alternate template file.
        file = ddlAlternateTemplate.SelectedItem.Value()
        ' Load the template and rebind the DataList control.
        DataList1.AlternatingItemTemplate = Me.LoadTemplate(file)
        BindDataList()
    End Sub

    ' Display the custom template

    Private Sub btnCustom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCustom.Click
        DataList1.AlternatingItemTemplate = Nothing
        DataList1.ItemTemplate = New MyCustomTemplate(Color.Blue, Color.White, Color.Cyan, Color.LightGreen)
        BindDataList()
    End Sub
End Class

' this is the custom template class

Class MyCustomTemplate
    Implements ITemplate

    Public ForeColor As Color
    Public BackColor As Color
    Public AltBackColor As Color
    Public AltBackColor2 As Color

    ' a suitable constructor
    Sub New(ByVal foreColor As Color, ByVal backColor As Color, ByVal altBackColor As Color, ByVal altBackColor2 As Color)
        Me.ForeColor = foreColor
        Me.BackColor = backColor
        Me.AltBackColor = altBackColor
        Me.AltBackColor2 = altBackColor2
    End Sub

    ' We must trap the DataBinding event for these controls.
    Dim WithEvents pan As Panel

    Public Sub InstantiateIn(ByVal container As System.Web.UI.Control) Implements System.Web.UI.ITemplate.InstantiateIn
        ' Get a strongly-typed reference to the containing item
        Dim dli As DataListItem = DirectCast(container, DataListItem)

        ' Create a panel with specified colors.
        pan = New Panel()
        pan.ForeColor = Me.ForeColor
        ' Use alternate colors for background.
        Select Case dli.ItemIndex Mod 3
            Case 0 : pan.BackColor = Me.BackColor
            Case 1 : pan.BackColor = Me.AltBackColor
            Case 2 : pan.BackColor = Me.AltBackColor2
        End Select
        ' Adapt to the container's size.
        pan.Width = dli.Width
        pan.Height = dli.Height

        ' Add controls to this panel.
        pan.Controls.Add(New LiteralControl("<b>"))
        pan.Controls.Add(New Label())                         ' this is the title field
        pan.Controls.Add(New LiteralControl("</b> - "))
        pan.Controls.Add(New Label())                         ' this is the price field

        ' Add the Panel control to the DataListItem control.
        dli.Controls.Add(pan)
    End Sub

    ' this event fires once for each item in the DataList, as it
    ' is being bound to the data source

    Private Sub pan_DataBinding(ByVal sender As Object, ByVal e As System.EventArgs) Handles pan.DataBinding
        ' Get a reference to the item container.
        ' (Note: cast to a DataGridItem if working with a DataGrid.)
        Dim dli As DataListItem = DirectCast(pan.NamingContainer, DataListItem)
        ' Get a reference to the data source row.
        ' (Note: cast to a DataRowView if binding to a DataTable/DataView.
        Dim dbr As System.Data.Common.DbDataRecord = DirectCast(dli.DataItem, System.Data.Common.DbDataRecord)

        ' Get the values of all the fields you're interested in
        ' and display them in the Panel child controls.
        Dim lblTitle As Label = DirectCast(pan.Controls(1), Label)
        lblTitle.Text = dbr("title").ToString
        ' This is the price Label control.
        Dim lblPrice As Label = DirectCast(pan.Controls(3), Label)

        If dbr("price").ToString.Length > 0 Then
            ' Display price if this field isn't Null.
            lblPrice.Text = "$" & dbr("price").ToString
            ' use special attributes for pricey titles.
            If CDec(dbr("price")) > 20 Then
                lblPrice.ForeColor = Color.Red
                lblPrice.Font.Bold = True
            End If
        Else
            ' Display special message for Null values
            lblPrice.Text = "(unknown price)"
            lblPrice.Font.Italic = True
        End If

    End Sub
End Class
