Imports System.Data.SqlClient

Public Class WebForm1
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub
    Protected WithEvents ddlTitles As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txtTitle As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPrice As System.Web.UI.WebControls.TextBox
    Protected WithEvents ddlPublishers As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txtType As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnSave As System.Web.UI.WebControls.Button
    Protected WithEvents TextBox1 As System.Web.UI.WebControls.TextBox

#End Region

    ' Define a connection object that points to Pubs.
    Dim cn As New SqlConnection(SqlPubsConnString)

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not IsPostBack Then
            ' Fill the two dropdownlist controls.
            FillListControl(ddlTitles, cn, "Titles", "title", "title_id")
            FillListControl(ddlPublishers, cn, "Publishers", "pub_name", "pub_id")
            ' Display the first record
            ShowTitleInfo(ddlTitles.Items(0).Value)
        End If
    End Sub

    ' Bind a List control to a table in a database.
    ' (Provider-agnostic code)
    Sub FillListControl(ByVal ctrl As ListControl, ByVal cn As IDbConnection, ByVal tableName As String, ByVal textField As String, ByVal valueField As String)
        ' Open the connection if necessary.
        If cn.State = ConnectionState.Closed Then cn.Open()
        Dim cmd As IDbCommand = cn.CreateCommand
        cmd.CommandText = String.Format("SELECT {0},{1} FROM {2}", textField, valueField, tableName)
        Dim dr As IDataReader = cmd.ExecuteReader
        ' Bind the control.
        ctrl.DataSource = dr
        ctrl.DataTextField = textField
        ctrl.DataValueField = valueField
        ctrl.DataBind()
        ' Close the DataReader.
        dr.Close()
    End Sub

    Sub ShowTitleInfo(ByVal titleId As String)
        ' Read info on a specific title.
        If cn.State = ConnectionState.Closed Then cn.Open()
        Dim cmd As New SqlCommand("SELECT * FROM Titles WHERE title_id='" & titleId & "'", cn)
        Dim dr As SqlDataReader = cmd.ExecuteReader(CommandBehavior.SingleRow)
        ' Fill all controls on the form.
        dr.Read()
        txtTitle.Text = dr("title").ToString
        txtPrice.Text = dr("price").ToString
        txtType.Text = dr("type").ToString
        ' Display the correct element in the ddlPublishers control.
        SelectItemFromValue(ddlPublishers, dr("pub_id").ToString)
        ' close the DataReader.
        dr.Close()
    End Sub

    Private Sub ddlTitles_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlTitles.SelectedIndexChanged
        ' Update fields on the form
        ShowTitleInfo(ddlTitles.SelectedItem.Value)
    End Sub

    ' Update a record in the title record.
    Sub UpdateTitle(ByVal title_id As String, ByVal title As String, ByVal price As String, ByVal type As String, ByVal pub_id As String)
        ' Prepare the update command
        Dim sql As String = "UPDATE Titles SET title=@title, price=@price, type=@type, pub_id=@pub_id WHERE title_id=@title_id"
        Dim cmd As New SqlCommand(sql, cn)
        cmd.Parameters.Add("@title", title)
        cmd.Parameters.Add("@price", CDec(price))
        cmd.Parameters.Add("@type", type)
        cmd.Parameters.Add("@pub_id", pub_id)
        cmd.Parameters.Add("@title_id", title_id)
        If cn.State = ConnectionState.Closed Then cn.Open()
        cmd.ExecuteNonQuery()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        ' Retrieve title_id and pub_id of visible record.
        Dim titleId As String = ddlTitles.SelectedItem.Value
        Dim pubId As String = ddlPublishers.SelectedItem.Value
        ' Update this record.
        UpdateTitle(titleId, txtTitle.Text, txtPrice.Text, txtType.Text, pubId)
        ' Ensure that the title in the dropdownlist control matches the new title.
        ddlTitles.SelectedItem.Text = txtTitle.Text
    End Sub

    Private Sub Page_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Unload
        ' CLose the connection if still open
        If cn.State <> ConnectionState.Closed Then cn.Close()
    End Sub
End Class
